unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, WebBrow, ComCtrls, Tabnotbk, Web, NewQt;

type
    TQuote = class(TObject)
     FCompany,
     FTicker,
     FLast,
     FHigh,
     FLow,
     FVolume,
     FAs_of,
     FChange,
     FYearHigh,
     FYearLow,
     FP_E,
     FExchange : string;
end;

type
  TForm1 = class(TForm)
    Start: TButton;
    WebBrowser1: TWebBrowser;
    ListBox1: TListBox;
    Panel1: TPanel;
    Label1: TLabel;
    Exit: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Panel3: TPanel;
    Label4: TLabel;
    Panel4: TPanel;
    Label5: TLabel;
    Panel5: TPanel;
    Label6: TLabel;
    Panel6: TPanel;
    Label7: TLabel;
    Panel7: TPanel;
    Label8: TLabel;
    Panel8: TPanel;
    Label9: TLabel;
    Panel9: TPanel;
    Label10: TLabel;
    Panel10: TPanel;
    Label11: TLabel;
    Panel11: TPanel;
    Label12: TLabel;
    Panel12: TPanel;
    Label13: TLabel;
    Label15: TLabel;
    Web1: TWeb;
    Bevel1: TBevel;
    Bevel2: TBevel;
    procedure WebBrowser1ExtractWord(Sender: TObject; BeginWord, EndWord,
      Text: string);
    procedure StartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Web1Connect(Sender: TObject);
    procedure Web1Disconnect(Sender: TObject);
    procedure Web1DataAvailable(Sender: TObject; Buffer: PChar;
      Len: Integer);
    procedure WebBrowser1DocumentAvailable(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    CurrQuoteIdx : integer;
    CurrQuote : TQuote;
    FBuff : string;
    procedure CreateQuoteObj(cm, tk : string);
    procedure DumpQuote(quote : TQuote);
    procedure GetQuote;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WebBrowser1ExtractWord(Sender: TObject; BeginWord,
  EndWord, Text: string);
begin
     with CurrQuote do
     begin
          if BeginWord = 'Last' then
             FLast := Text;
          if BeginWord = 'High' then
             FHigh := Text;
          if BeginWord = 'Low' then
             FLow := Text;
          if BeginWord = 'Volume' then
             FVolume := Text;
          if BeginWord = 'As of' then
             FAs_of := Text;
          if BeginWord = 'Change' then
             FChange := Text;
          if BeginWord = 'YearHigh' then
             FYearHigh := Text;
          if BeginWord = 'YearLow' then
             FYearLow := Text;
          if BeginWord = 'P/E' then
             FP_E := Text;
          if BeginWord = 'Exchange' then
             FExchange := Text;
     end;
     DumpQuote(CurrQuote);
end;

procedure TForm1.StartClick(Sender: TObject);
begin
     if TButton(Sender).Caption = 'Start' then
     begin
          Button1.Enabled := False;
          Button2.Enabled := False;
          Button3.Enabled := False;
          Exit.Enabled := False;
          Start.Caption := 'Stop';
          CurrQuoteIdx := 0;
          GetQuote;
     end
     else
     begin
          if Web1.Retrieving then Web1.Abort;
          Button1.Enabled := True;
          Button2.Enabled := True;
          Button3.Enabled := True;
          Exit.Enabled := True;
          Start.Caption := 'Start';
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     CreateQuoteObj('Borland Iternational Inc.', 'BORL');
     CreateQuoteObj('Microsoft Corporation', 'MSFT');
     CreateQuoteObj('Netscape Communication Inc.', 'NSCP');
     CreateQuoteObj('NetManage', 'NETM');
     CreateQuoteObj('International Business Machines', 'IBM');
     WebBrowser1.ExtractWordList.Clear;
end;

procedure TForm1.GetQuote;
var
   s : string;
begin
     if CurrQuoteIdx <= Pred(ListBox1.Items.Count) then
     begin
          ListBox1.ItemIndex := CurrQuoteIdx;
          CurrQuote := TQuote(ListBox1.Items.Objects[CurrQuoteIdx]);
          Inc(CurrQuoteIdx);
          s := Copy(CurrQuote.FTicker,1,1);
          Web1.Url := 'http://www.stockmaster.com/sm/g/'+s+'/'+CurrQuote.FTicker+'.html';
          Web1.Retrieve;
          Panel1.Caption := 'Contacting StockMaster';
     end
     else
     begin
         Panel1.Caption := 'Idle';
         Button1.Enabled := True;
         Button2.Enabled := True;
         Button3.Enabled := True;
         Exit.Enabled := True;
         Start.Caption := 'Start';
     end;
end;

procedure TForm1.CreateQuoteObj(cm, tk : string);
var
   qt : TQuote;
begin
     qt := TQuote.Create;
     qt.FCompany := cm;
     qt.FTicker := tk;
     ListBox1.Items.AddObject(cm, qt);
end;

procedure TForm1.ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   qt : TQuote;
begin
   if ListBox1.ItemIndex >= 0 then
   begin
      qt := TQuote(ListBox1.Items.Objects[ListBox1.ItemIndex]);
      DumpQuote(qt);
   end;
end;

procedure TForm1.DumpQuote(quote : TQuote);
begin
     with quote do
     begin
          Label2.Caption := FCompany+' (' +UpperCase(FTicker)+')';
          Label3.Caption := FCompany+' (' +UpperCase(FTicker)+')';
          Panel3.Caption := FLast;
          Panel4.Caption := FHigh;
          Panel5.Caption := FLow;
          Panel6.Caption := FVolume;
          Panel7.Caption := FAs_Of;
          Panel8.Caption := FChange;
          Panel9.Caption := FYearHigh;
          Panel10.Caption := FYearLow;
          Panel11.Caption := FP_E;
          Panel12.Caption := FExchange;
     end;
end;

procedure TForm1.Web1Connect(Sender: TObject);
begin
     FBuff := '';
     Panel1.Caption := 'StockMaster answered. Querying ' + UpperCase(CurrQuote.FCompany);
end;

procedure TForm1.Web1Disconnect(Sender: TObject);
begin
     Panel1.Caption := 'StockMaster closed communication';
     WebBrowser1.ExtractWordList.Clear;
     if Pos('NYSE', UpperCase(FBuff)) > 0 then
     with WebBrowser1.ExtractWordList do
     begin
          Add('Last' + #255 + 'High');
          Add('High' + #255 + 'Low');
          Add('Low' + #255 + 'Volume');
          Add('Volume' + #255 + 'Div');
          Add('As of' + #255 + 'Change');
          Add('Change' + #255 + 'YearHigh');
          Add('YearHigh' + #255 + 'YearLow');
          Add('YearLow' + #255 + 'P/E');
          Add('P/E' + #255 + 'Yield');
          Add('Exchange' + #255 + '[');
     end
     else
     with WebBrowser1.ExtractWordList do
     begin
          Add('Last' + #255 + 'High');
          Add('High' + #255 + 'Low');
          Add('Low' + #255 + 'Volume');
          Add('Volume' + #255 + 'As of');
          Add('As of' + #255 + 'Change');
          Add('Change' + #255 + 'YearHigh');
          Add('YearHigh' + #255 + 'YearLow');
          Add('YearLow' + #255 + 'P/E');
          Add('P/E' + #255 + 'Exchange');
          Add('Exchange' + #255 + '[');
     end;

     WebBrowser1.Source := FBuff;
     WebBrowser1.ParseBuffer;
end;

procedure TForm1.Web1DataAvailable(Sender: TObject; Buffer: PChar;
  Len: Integer);
begin
     FBuff := FBuff + string(Buffer);
     Panel1.Caption := 'Receving ' + UpperCase(CurrQuote.FCompany) + ' quote [' + IntToStr(Length(Fbuff)) + ' bytes read]';
end;

procedure TForm1.WebBrowser1DocumentAvailable(Sender: TObject);
begin
     GetQuote;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   newqt : TNewQTDlg;
   qt : TQuote;
begin
     newqt := TNewQTDlg.Create(Application);
     newqt.ShowModal;
     if newqt.ModalResult = mrOk then
     begin
          qt := TQuote.Create;
          qt.FCompany := newqt.Edit1.Text;
          qt.FTicker := newqt.Edit2.Text;
          ListBox1.Items.AddObject(qt.FCompany, qt);
     end;
     newqt.Release;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   qt : TQuote;
begin
     if ListBox1.ItemIndex >= 0 then
     begin
          qt := TQuote(ListBox1.Items.Objects[ListBox1.ItemIndex]);
          qt.free;
          ListBox1.Items.Delete(ListBox1.ItemIndex);
     end;

     if ListBox1.Items.Count > 0 then
     begin
          qt := TQuote(ListBox1.Items.Objects[0]);
          DumpQuote(qt);
     end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   qt : TQuote;
   x : integer;
begin
     for x:= Pred(ListBox1.Items.Count) downto 0 do
     begin
          qt := TQuote(ListBox1.Items.Objects[0]);
          qt.free;
          ListBox1.Items.Delete(0);
     end;
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     Button3Click(Self);
end;

end.
