unit Retrieve;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, INIFiles, Web, Globals,
  Setting, Webproxy, WebImage;

type
  TWeather = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    DoRetrieve: TButton;
    DCounter: TLabel;
    DTitle: TLabel;
    Label3: TLabel;
    Status: TLabel;
    Panel2: TPanel;
    RetAbort: TButton;
    Config: TButton;
    Quit: TButton;
    WebProxy1: TWebProxy;
    ComboBox1: TComboBox;
    WebImage1: TWebImage;
    procedure Timer1Timer(Sender: TObject);
    procedure Web1Connect(Sender: TObject);
    procedure Web1Disconnect(Sender: TObject);
    procedure DoRetrieveClick(Sender: TObject);
    procedure ConfigClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure RetAbortClick(Sender: TObject);
    procedure WebImage1Read(Sender: TObject);
    procedure WebImage1Error(Sender: TObject; ErrorCode: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure Transform;
    procedure GetImage;
  public
    { Public declarations }
  end;

var
  Weather: TWeather;
  TimeCounter : integer;


implementation

{$R *.DFM}

procedure TWeather.Timer1Timer(Sender: TObject);
begin
     { Wait 'til fixed Idle time elapsed then trigger image retrieving}
     Inc(TimeCounter);
     if TimeCounter > Idle then
     begin
        Weather.RetAbort.Enabled := True;
        GetImage;
     end;

end;

procedure TWeather.Web1Connect(Sender: TObject);
begin
     Status.Caption := 'Connecting...';
end;

procedure TWeather.Web1Disconnect(Sender: TObject);
begin
     Weather.RetAbort.Enabled := False;
     Transform;
end;

procedure TWeather.DoRetrieveClick(Sender: TObject);
begin
     Weather.RetAbort.Enabled := True;
     GetImage;
end;

procedure TWeather.Transform;
var
   Buffer : array[0..40] of Char;    {To hold temporary path name in null format }
   Buffer1 : array[0..40] of Char;   {To hold temporary path name in null format }
begin
          if Stamp then
          begin
               WebImage1.SaveBMP(WorkDir + 'europe.bmp');
               StrPCopy(Buffer,WorkDir + 'europe.bmp');
               SystemParametersInfo(SPI_SETDESKWALLPAPER,0,@Buffer,0);
          end;

          Status.Caption := 'Waiting';

          Timer1.Enabled := true;
          DoRetrieve.Enabled := true;
end;

procedure TWeather.GetImage;
var
  mapname : Integer;
begin
     TimeCounter := 0;

     with Weather do
     begin
          Timer1.Enabled := False;
          DoRetrieve.Enabled := False;
          Status.Caption := 'Initializing...';
     end;

     with WebImage1 do
     begin
          case ComboBox1.ItemIndex of
            0: URL := 'http://cnn.com/WEATHER/accu.data/aussat.gif';
            1: URL := 'http://cnn.com/WEATHER/accu.data/eursat.gif';
            2: URL := 'http://www.univie.ac.at/ZAMG/sat.gif';
            3: URL := 'http://cnn.com/WEATHER/accu.data/ussat.gif';
            4: URL := 'http://cnn.com/WEATHER/accu.data/samsat.gif';
            5: URL := 'http://cnn.com/WEATHER/accu.data/asiasat.gif';
            6: URL := 'http://cnn.com/WEATHER/accu.data/afsat.gif';
            7: URL := 'http://cnn.com/WEATHER/accu.data/midsat.gif';
          end;

     end;
     WebImage1.Retrieve;
end;

procedure TWeather.ConfigClick(Sender: TObject);
begin
     with Settings, WIni do
     begin
          UseProxy.Checked := ReadBool('Settings','UseProxy',False);
          PName.Text := ReadString('Settings','Proxy','');
          PPort.Text := ReadString('Settings','ProxyPort','');
          WDir.Text := ReadString('Settings','WorkDir','C:\');
          ICount.Value := ReadInteger('Settings','Idle',30);
          DoStamp.Checked := ReadBool('Settings','Stamp',True);
          DoRecolor.Checked := ReadBool('Settings','Recolor',True);
     end;

     Settings.ShowModal;
end;

procedure TWeather.QuitClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TWeather.RetAbortClick(Sender: TObject);
begin
     Weather.WebImage1.Abort;
     Weather.RetAbort.Enabled := False;
end;

procedure TWeather.WebImage1Read(Sender: TObject);
begin
     { Update retrieving info }
     DTitle.Caption := 'Size:';
     Status.Caption := 'Retrieving...';
     DCounter.Caption := IntToStr(WebImage1.Size);
end;

procedure TWeather.WebImage1Error(Sender: TObject; ErrorCode: Integer);
begin
          Weather.Status.Caption := 'Waiting';
          Weather.Timer1.Enabled := true;
          Weather.DoRetrieve.Enabled := true;
end;

procedure TWeather.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex := 0;
end;

initialization
TimeCounter := 0;
with WIni do
begin
     UProxy := ReadBool('Settings','UseProxy',False);
     ProxyName := ReadString('Settings','Proxy','');
     ProxyPortNumber := ReadString('Settings','ProxyPort','');
     WorkDir := ReadString('Settings','WorkDir','');
     Idle := ReadInteger('Settings','Idle',30);
     Stamp := ReadBool('Settings','Stamp',True);
     Recolor := ReadBool('Settings','Recolor',True);
end;

end.
