unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Web, ExtCtrls, StdCtrls, Inifiles, Grids;

type
  TMainform = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Panel1: TPanel;
    Button3: TButton;
    Button4: TButton;
    Label2: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Web1: TWeb;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Web1Connect(Sender: TObject);
    procedure Web1DataAvailable(Sender: TObject; Buffer: PChar;
      Len: Integer);
    procedure Web1Disconnect(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    MaxItems,
    CurrItem : Integer;
    webdata : string;
    procedure KickWhoIs;
  public
    { Public declarations }
  end;

var
  Mainform: TMainform;

implementation

{$R *.DFM}

procedure TMainform.Button1Click(Sender: TObject);
begin
     if Edit1.Text <> '' then
     begin
             ListBox1.Items.Add(Edit1.Text);
             ListBox2.Items.Add('Unchecked');
             Edit1.Text := '';
     end;
end;

procedure TMainform.Button2Click(Sender: TObject);
var
   x : integer;
begin
     if ListBox1.ItemIndex <> -1 then
     begin
          x := ListBox1.ItemIndex;
          ListBox1.Items.Delete(x);
          ListBox2.Items.Delete(x);
          Edit1.Text := '';
     end;
end;

procedure TMainform.Button4Click(Sender: TObject);
var
   Ini : TInifile;
   x : integer;
begin
     Ini := TIniFile.Create('NIC.INI');
     Ini.EraseSection('HOST_NAMES');
     Ini.WriteInteger('HOST_NAMES', 'NumHosts', ListBox1.Items.Count);
     for x:= 0 to Pred(ListBox1.Items.Count) do
         Ini.WriteString('HOST_NAMES', 'Host'+IntToStr(Succ(x)), ListBox1.Items[x]);
     Ini.Free;
     Application.Terminate;
end;

procedure TMainform.FormCreate(Sender: TObject);
var
   Ini : TInifile;
   x, y : integer;
begin
     Ini := TIniFile.Create('NIC.INI');
     x := Ini.ReadInteger('HOST_NAMES', 'NumHosts', 0);
     for y:= 0 to Pred(x) do
     begin
         ListBox1.Items.Add(Ini.ReadString('HOST_NAMES', 'Host'+IntToStr(Succ(y)),''));
         ListBox2.Items.Add('Unchecked');
     end;
     Ini.Free;
end;

procedure TMainform.Button3Click(Sender: TObject);
begin
     if TButton(Sender).Caption = 'WhoIs' then
     begin
          if ListBox1.Items.Count > 0 then
          begin
               Button1.Enabled := False;
               Button2.Enabled := False;
               Button3.Caption := 'Stop';
               Button4.Enabled := False;
               CurrItem := 0;
               KickWhoIs;
          end;
     end
     else
     begin
          Web1.Abort;
          Panel1.Caption := 'Idle';
          if ListBox1.Items.Count > 0 then
             ListBox1.ItemIndex := 0;
          Button1.Enabled := True;
          Button2.Enabled := True;
          Button3.Caption := 'WhoIs';
          Button4.Enabled := True;
     end;
end;

procedure TMainform.KickWhoIs;
begin
     MaxItems := Pred(ListBox1.Items.Count);
     if CurrItem <= MaxItems then
     begin
          ListBox1.ItemIndex := CurrItem;
          webdata := '';
          ListBox2.Items[ListBox1.ItemIndex] := 'Checking';
          Web1.Url := 'http://whois.internic.net/cgi-bin/whois?'+ListBox1.Items[ListBox1.ItemIndex];
          Panel1.Caption := 'Contacting Host Internic';
          Web1.Retrieve;
     end
     else
         Button3Click(Self);
end;


procedure TMainform.Web1Connect(Sender: TObject);
begin
     Panel1.Caption := 'Internic is alive';
end;

procedure TMainform.Web1DataAvailable(Sender: TObject; Buffer: PChar;
  Len: Integer);
begin
     ListBox1.ItemIndex := CurrItem;
     Panel1.Caption := 'Querying '+ ListBox1.Items[ListBox1.ItemIndex];
     webdata := webdata + string(Buffer);
end;

procedure TMainform.Web1Disconnect(Sender: TObject);
begin
     Panel1.Caption := 'Idle';
     ListBox1.ItemIndex := CurrItem;
     if Pos('NO MATCH', UpperCase(webdata)) > 0 then
          ListBox2.Items[ListBox1.ItemIndex] := 'Not found'
     else
          ListBox2.Items[ListBox1.ItemIndex] := 'Found';
     Inc(CurrItem);
     KickWhoIs;
end;

procedure TMainform.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
     if key = #13 then
     begin
          key := #0;
          Button1Click(Self);
     end;
end;

end.
